## libgnatcoll-db 18

=== xref/Makefile ===
##############################################################################
##                                                                          ##
##                              GNATCOLL LIBRARY                            ##
##                                                                          ##
##                         Copyright (C) 2017, AdaCore.                     ##
##                                                                          ##
## This library is free software;  you can redistribute it and/or modify it ##
## under terms of the  GNU General Public License  as published by the Free ##
## Software  Foundation;  either version 3,  or (at your  option) any later ##
## version. This library is distributed in the hope that it will be useful, ##
## but WITHOUT ANY WARRANTY;  without even the implied warranty of MERCHAN# ##
## TABILITY or FITNESS FOR A PARTICULAR PURPOSE.                            ##
##                                                                          ##
## As a special exception under Section 7 of GPL version 3, you are granted ##
## additional permissions described in the GCC Runtime Library Exception,   ##
## version 3.1, as published by the Free Software Foundation.               ##
##                                                                          ##
## You should have received a copy of the GNU General Public License and    ##
## a copy of the GCC Runtime Library Exception along with this program;     ##
## see the files COPYING3 and COPYING.RUNTIME respectively.  If not, see    ##
## <http://www.gnu.org/licenses/>.                                          ##
##                                                                          ##
##############################################################################

# Makefile targets
# ----------------
#
# Setup:                   make [VAR=VALUE] setup (see below)
# Build:                   make
# Install:                 make install

# Variables which can be set:
#
# General:
#
#   prefix        : root install directory
#   ENABLE_SHARED : yes / no (or empty)
#   BUILD         : DEBUG PROD
#   PROCESSORS    : nb parallel compilations (0 to use all cores)
#   TARGET        : target triplet for cross-compilation
#   INTEGRATED    : installs the project as part of the compiler installation;
#                   this adds NORMALIZED_TARGET subdir to prefix

# helper programs
CAT := cat
ECHO  := echo
WHICH := which

NAME=gnatcoll_xref

# check for out-of-tree build
SOURCE_DIR := $(dir $(MAKEFILE_LIST))
ifeq ($(SOURCE_DIR),./)
  RBD=
  GNATCOLL_GPR=$(NAME).gpr
  MAKEPREFIX=
else
  RBD=--relocate-build-tree
  GNATCOLL_GPR=$(SOURCE_DIR)/$(NAME).gpr
  MAKEPREFIX=$(SOURCE_DIR)/
endif

TARGET := $(shell gcc -dumpmachine)
NORMALIZED_TARGET := $(subst normalized_target:,,$(wordlist 6,6,$(shell gprconfig  --config=ada --target=$(TARGET) --mi-show-compilers)))
ifeq ($(NORMALIZED_TARGET),)
  $(error No toolchain found for target "$(TARGET)")
endif

prefix := $(dir $(shell $(WHICH) gnatls))..
GNATCOLL_VERSION := $(shell $(CAT) $(SOURCE_DIR)/../version_information)

BUILD         = PROD
PROCESSORS    = 0
BUILD_DIR     =
ENABLE_SHARED := yes
INTEGRATED    = no

all: build

# Load current setup if any
-include makefile.setup

GTARGET=--target=$(NORMALIZED_TARGET)

ifeq ($(ENABLE_SHARED), yes)
   LIBRARY_TYPES=static relocatable static-pic
else
   LIBRARY_TYPES=static
endif

ifeq ($(INTEGRATED), yes)
   integrated_install=/$(NORMALIZED_TARGET)
endif

GPR_VARS= \
	 -XGNATCOLL_VERSION=$(GNATCOLL_VERSION) \
	 -XBUILD=$(BUILD)

# Used to pass extra options to GPRBUILD, like -d for instance
GPRBUILD_OPTIONS=

BUILDER=gprbuild -p -m $(GTARGET) $(RBD) -j$(PROCESSORS) $(GPR_VARS) \
	$(GPRBUILD_OPTIONS)
INSTALLER=gprinstall -p -f --target=$(TARGET) $(GPR_VARS) \
	$(RBD) --sources-subdir=include/$(NAME) --prefix=$(prefix)$(integrated_install)
CLEANER=gprclean -q $(RBD) $(GPR_VARS)
UNINSTALLER=$(INSTALLER) -p -f --install-name=$(NAME) --uninstall

#########
# build #
#########

build: $(LIBRARY_TYPES:%=build-%)

build-%:
	$(BUILDER) -XLIBRARY_TYPE=$* -XXMLADA_BUILD=$* -XGPR_BUILD=$* \
		$(GNATCOLL_GPR)

###########
# Install #
###########

uninstall:
ifneq (,$(wildcard $(prefix)/share/gpr/manifests/$(NAME)))
	$(UNINSTALLER) $(GNATCOLL_GPR)
endif

install: uninstall $(LIBRARY_TYPES:%=install-%)

install-%:
	$(INSTALLER) -XLIBRARY_TYPE=$* -XXMLADA_BUILD=$* -XGPR_BUILD=$* \
		--build-name=$* --build-var=LIBRARY_TYPE $(GNATCOLL_GPR)

###########
# Cleanup #
###########

clean: $(LIBRARY_TYPES:%=clean-%)

clean-%:
	-$(CLEANER) -XLIBRARY_TYPE=$* -XXMLADA_BUILD=$* -XGPR_BUILD=$* \
		$(GNATCOLL_GPR)

#########
# setup #
#########

.SILENT: setup

setup:
	$(ECHO) "prefix=$(prefix)" > makefile.setup
	$(ECHO) "ENABLE_SHARED=$(ENABLE_SHARED)" >> makefile.setup
	$(ECHO) "INTEGRATED=$(INTEGRATED)" >> makefile.setup
	$(ECHO) "BUILD=$(BUILD)" >> makefile.setup
	$(ECHO) "PROCESSORS=$(PROCESSORS)" >> makefile.setup
	$(ECHO) "TARGET=$(TARGET)" >> makefile.setup
	$(ECHO) "SOURCE_DIR=$(SOURCE_DIR)" >> makefile.setup
	$(ECHO) "GNATCOLL_VERSION=$(GNATCOLL_VERSION)" >> makefile.setup

# Let gprbuild handle parallelisation. In general, we don't support parallel
# runs in this Makefile, as concurrent gprinstall processes may crash.
.NOTPARALLEL:

=== debian/changelog ===
libgnatcoll-db (18-4) unstable; urgency=medium

  * Rebuild in unstable for gnat-8 transition.

 -- Nicolas Boulenguez <nicolas@debian.org>  Sat, 27 Oct 2018 15:09:59 +0200

libgnatcoll-db (18-3) experimental; urgency=medium

  * Link with pthread on architectures affected by #760211.
  * Standards-Version: 4.2.0. Rules-Requires-Root: no.

 -- Nicolas Boulenguez <nicolas@debian.org>  Fri, 03 Aug 2018 20:58:05 +0200

libgnatcoll-db (18-2) experimental; urgency=medium

  * Unset Library_Interface in sqlite project,
    restoring the symbols from the builder and gnade components.
  * Prevent such regressions with a runtime test.
  * Move LDFLAGS before libraries also when linking executables.

 -- Nicolas Boulenguez <nicolas@debian.org>  Sun, 01 Jul 2018 22:47:36 +0200

libgnatcoll-db (18-1) experimental; urgency=medium

  * New upstream version, splitting the libgnatcoll source package.
    Repackage this component without the huge copy of sqlite generated code.
  * No ALI/SO package renaming in experimental, but two new binary packages:
    libgnatcoll-sqlSO and libgnatcoll-sqlALI-dev.
  * Replace gnatcoll_db2ada executable name with new upstream name
    depending on the backend: gnatcoll_sqlite2ada.
  * Fix language list in sqlite module (error with dh_ada_library).
  * Remove -l options for static libraries (error with recent gprbuild).
  * Rewrite d/rules sequentially. The build must be strictly linear, so
    using Make syntax only leads to confusion.
  * Add a minimal run time test.

 -- Nicolas Boulenguez <nicolas@debian.org>  Sun, 24 Jun 2018 15:43:05 +0200

libgnatcoll (17.0.2017-5) experimental; urgency=medium

  * Rebuild with gnat-8, libgpr1-dev, libgtkada18-dev..
    Rename shared libraries and -dev packages per Debian Ada policy.
  * Remove watch file. Explain why in README.source.
  * Install documentation to libgnatcoll-doc.
    Doc is shared for all -dev packages, so the effort is wasted.
  * Remove override for lintian pedantic messages.
  * Update upstream home page.
  * Use forgotten sphinxdoc:Built-Using substitution variable.

 -- Nicolas Boulenguez <nicolas@debian.org>  Tue, 08 May 2018 08:13:15 +0200

libgnatcoll (17.0.2017-4) unstable; urgency=medium

  * Upload to unstable.
  * Break+Replace: previous gtkada-dev package per Ada policy. Closes: #896570.
  * Standards-Version: 4.1.4.

 -- Nicolas Boulenguez <nicolas@debian.org>  Tue, 24 Apr 2018 17:17:56 +0200

libgnatcoll (17.0.2017-4~pre1) experimental; urgency=medium

  * Rebuild with libgtkada-dev updating gtk-gir, fixing gnat-gps.
    Ada policy requires a renaming of the libgnatcoll-gtk-dev package,
    but the fix does not affect the gnatcoll ABI and SO version.
  * Debhelper 11 and Standards-Version: 4.1.3.
    Move docs from /u/s/doc/*-doc to /u/s/doc/*-dev.
  * Build-Depends: drop obsolete version restriction on dpkg-dev.
  * python_single_statement_set_default_console.diff: fix serious typo.
  * Build-Depend: drop dpkg-dev obsolete version restriction.

 -- Nicolas Boulenguez <nicolas@debian.org>  Sat, 03 Mar 2018 14:28:59 +0100

libgnatcoll (17.0.2017-3) unstable; urgency=medium

  * Make testsuite more verbose. Closes: #872081.
  * Build-Depend latexmk for LaTeX sphinx-doc module. Closes: #872204.
  * Build-Depend: python3 version of sphinx-doc. Patch conf.py.
  * Standards-Version: 4.1.0.
  * Rebuild with libgpr 2017-5 (because of libxmlada-unicode).
    -dev version is already new in testing.

 -- Nicolas Boulenguez <nicolas@debian.org>  Tue, 26 Sep 2017 16:54:43 +0200

libgnatcoll (17.0.2017-2) unstable; urgency=medium

  * Upload to unstable.
  * The switch to gcc-7 requires a SO version bump for each library,
    except gnatcoll, g-python, g-xref, already new in unstable.
    The Break/Replace with previous -dev becomes implicit in unstable.
  * Disable parallel doc generation to prevent #869098.
  * Standards-Version: 4.0.1. Priority: optional.
  * Vcs-Mtn: new URI format.
  * clean objects forgotten by aclocal.m4.
  * Build-Depends: renamed texlive-plain-generic.

 -- Nicolas Boulenguez <nicolas@debian.org>  Thu, 10 Aug 2017 12:42:17 +0200

libgnatcoll (17.0.2017-1) experimental; urgency=medium

  * New upstream release, two new packages for the gnatcoll-xref library.
    No ALI/SO bump in experimental.
  * Build with gnat-7, which deals with SOURCE_DATE_EPOCH directly.
  * Debhelper 10, which deals with autoconf generated stuff.
  * Standards-Version: 4.0.0. Downgrade -doc to Suggests.
    HTTPS URL for copyright format. Handle DEB_BUILD_OPTIONS=nodoc.
  * Allow -doc package to satisfy multi-arch foreign dependencies.
  * PDFLatex now handles SOURCE_DATE_EPOCH without faketime.

 -- Nicolas Boulenguez <nicolas@debian.org>  Tue, 11 Jul 2017 01:44:33 +0200

libgnatcoll (16.1.0-1) experimental; urgency=medium

  * New upstream release. Update to ligtkada16.1.0-dev.
    Replace libgnatprj/vsn, dropped by GCC with libgpr from gprbuild.
    Bump ALI versions and conflict/break previous -dev per Ada policy.
    Bump SO versions for gnatcoll and gnatcoll-python.
  * Remove many patches to upstream Makefile and invoke gprbuild directly.
    Upstream prefers a reduced set of well tested configurations.
  * remove generate-sources-timestamp.diff, but regenerate the sources after
    the build and fail if they differ with the ones from the tarball.
  * python_single_statement_set_default_console.diff was waiting an ALI bump.
  * Select all hardening flags, gprbuild will override pie when needed.
  * C sources, ignored in ALI files, do not require predictible timestamps.
  * Simplify watch file thanks to version 4 format.

 -- Nicolas Boulenguez <nicolas@debian.org>  Sun, 21 Aug 2016 17:48:30 +0200

libgnatcoll (1.7gpl2015-2) unstable; urgency=medium

  * Revert to python2 as long as most startup scripts in the gnat-gps
    reverse dependency are incompatible with python3. Reopens: #760004.
  * Build-Depend: texlive-generic-extra for iftex.sty. Closes: #830334.


=== debian/control ===
Source: libgnatcoll-db
Priority: optional
Section: misc
Maintainer: Nicolas Boulenguez <nicolas@debian.org>
Build-Depends: debhelper (>= 11),
 gnat, gnat-8,
# This line is parsed to set gnat version.
# dh-ada-library allowing .ada extension.
 dh-ada-library (>= 6.10),
# gprbuild cleaning auto.cgpr.
 gprbuild (>= 2017),
 libgnatcoll17-dev,
 libgnatcoll-iconv17-dev,
 libsqlite3-dev
Homepage: https://www.adacore.com/community
Standards-Version: 4.2.0
Rules-Requires-Root: no

######################################################################

Package: libgnatcoll-sqlite17-dev
Section: libdevel
Architecture: any
Depends: libsqlite3-dev, ${misc:Depends}, ${ada:Depends}
Suggests: libgnatcoll-doc
Description: GNATColl, general purpose Ada library (SQLite)
 The GNAT Component Collection deals with: module tracing, efficient
 file IO, static string searching (Boyer-Moore), e-mails and
 mailboxes, Ravenscar tasking profiles, storage pools, JSON, logging,
 shell scripting. Components relying on external dependencies are
 distributed in separate packages.
 .
 This package contains the static library and Ada specifications
 dedicated to SQLite databases manipulation.

Package: libgnatcoll-sqlite18
Section: libs
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: GNATColl, general purpose Ada library (sqlite runtime)
 The GNAT Component Collection deals with: module tracing, efficient
 file IO, static string searching (Boyer-Moore), e-mails and
 mailboxes, Ravenscar tasking profiles, storage pools, JSON, logging,
 shell scripting. Components relying on external dependencies are
 distributed in separate packages.
 .
 This package contains the runtime shared library for the SQLite
 extension.

Package: libgnatcoll-sqlite-bin
Section: devel
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
# gnat-gps used to provide gnatinspect.
Breaks: gnat-gps (<< 5.3-4)
Replaces: gnat-gps (<< 5.3-4)
Suggests: libgnatcoll-doc
Description: GNATColl, general purpose Ada library (SQLite tools)
 The GNAT Component Collection deals with: module tracing, efficient
 file IO, static string searching (Boyer-Moore), e-mails and
 mailboxes, Ravenscar tasking profiles, storage pools, JSON, logging,
 shell scripting. Components relying on external dependencies are
 distributed in separate packages.
 .
 This package contains the tools dedicated to SQLite database
 manipulation (gnatcoll_db2ada and gnatinspect).
 .
 The former only accepts the sqlite backend, because the PostGreSQL
 library and the non-commercial GNATColl carry incompatible licenses.

######################################################################

Package: libgnatcoll-sql1-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends}, ${ada:Depends}
Suggests: libgnatcoll-doc
Description: GNATColl, general purpose Ada library (SQL)
 The GNAT Component Collection deals with: module tracing, efficient
 file IO, static string searching (Boyer-Moore), e-mails and
 mailboxes, Ravenscar tasking profiles, storage pools, JSON, logging,
 shell scripting. Components relying on external dependencies are
 distributed in separate packages.
 .
 This package contains the static library and Ada specifications
 dedicated to SQL databases manipulation.
 .
 It connects to actual databases via a sqlite or a postgres backend,
 but only the former exists in Debian due to license reasons.

Package: libgnatcoll-sql1
Section: libs
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: GNATColl, general purpose Ada library (SQL runtime)
 The GNAT Component Collection deals with: module tracing, efficient
 file IO, static string searching (Boyer-Moore), e-mails and
 mailboxes, Ravenscar tasking profiles, storage pools, JSON, logging,
 shell scripting. Components relying on external dependencies are
 distributed in separate packages.
 .
 This package contains the runtime shared library for the SQL
 extension.

######################################################################

Package: libgnatcoll-xref18-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends}, ${ada:Depends}
Suggests: libgnatcoll-doc
Description: GNATColl, general purpose Ada library (XRef)
 The GNAT Component Collection deals with: module tracing, efficient
 file IO, static string searching (Boyer-Moore), e-mails and
 mailboxes, Ravenscar tasking profiles, storage pools, JSON, logging,
 shell scripting. Components relying on external dependencies are
 distributed in separate packages.
 .
 This package contains the static library and Ada specifications
 for the XRef extension.

Package: libgnatcoll-xref18
Section: libs
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: GNATColl, general purpose Ada library (XRef runtime)
 The GNAT Component Collection deals with: module tracing, efficient
 file IO, static string searching (Boyer-Moore), e-mails and
 mailboxes, Ravenscar tasking profiles, storage pools, JSON, logging,
 shell scripting. Components relying on external dependencies are
 distributed in separate packages.
 .
 This package contains the runtime shared library for the XRef
 extension.

=== debian/rules ===
#!/usr/bin/make -f
# Build script for GNATColl in Debian.
# Copyright (c) 2014-2018 Nicolas Boulenguez <nicolas@debian.org>

# This build script is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License as
# published by the Free Software Foundation; either version 3 of the
# License, or (at your option) any later version.

# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.

# On Debian systems, the full text of the GPL is in the file
# /usr/share/common-licenses/GPL-3.

$(foreach line,$(shell sed -n '\
  s/^ gnat, gnat-\([0-9.]\+\),$$/GNAT_VERSION:=\1/p; \
  s/^Package: libgnatcoll-\([a-z]\+\)\([0-9.]\+\)$$/gnatcoll_\1_version:=\2/p; \
  ' debian/control),$(eval $(line)))

DEB_BUILD_MAINT_OPTIONS := hardening=+all
include /usr/share/dpkg/default.mk
include /usr/share/ada/debian_packaging-$(GNAT_VERSION).mk

# The scenario variables passed to gprbuild and dh_ada_library.
BUILD := PROD
GNATCOLL_SQLITE := external
vars := \
  gnatcoll_sql_version \
  gnatcoll_sqlite_version \
  gnatcoll_xref_version \
  ADAFLAGS CFLAGS CPPFLAGS LDFLAGS \
  BUILD \
  GNATCOLL_SQLITE \

gpr_opts := -p $(BUILDER_OPTIONS) $(foreach v,$(vars),-X$(v)="$($(v))")

%:
	dh $@ --with ada-library

# Dependencies and parallelism are handled by gprbuild,
# avoid using Make for this (risky, without much gain).
# Anyway, there is only one possible build order.
# For the same reason, blindly regenerate xref/generated.

.PHONY: override_dh_auto_build
override_dh_auto_build:

	gprbuild sql/gnatcoll_sql.gpr \
	  -XLIBRARY_TYPE=static $(gpr_opts)
	gprbuild sql/gnatcoll_sql.gpr \
	  -XLIBRARY_TYPE=relocatable $(gpr_opts)

	gprbuild sqlite/gnatcoll_sqlite.gpr \
	  -XLIBRARY_TYPE=static -aPsql $(gpr_opts)
	gprbuild sqlite/gnatcoll_sqlite.gpr \
	  -XLIBRARY_TYPE=relocatable -aPsql $(gpr_opts)

	gprbuild gnatcoll_db2ada/gnatcoll_sqlite2ada.gpr \
	  -XLIBRARY_TYPE=relocatable -aPsql -aPsqlite $(gpr_opts)

# TODO: ask upstream to provide initialdata.txt and this Makefile
# snippet. They have probably forgotten them during the libgnatcoll
# source package split.
	rm -fr xref/generated
	mkdir xref/generated
	LD_LIBRARY_PATH=sql/lib/relocatable:sqlite/lib/relocatable \
	  gnatcoll_db2ada/obj/gnatcoll_sqlite2ada \
	  -dbname=:memory: \
	  -output xref/generated \
	  -dbmodel=gnatcoll_db2ada/dbschema.txt \
	  -createdb \
	  -adacreate \
	  -api GNATCOLL.Xref.Database \
	  -load=debian/initialdata.txt \
	  -enum "f2f_kind,id,name,F2F,Integer" \
	  -enum "e2e_kind,id,name,E2E,Integer"

	gprbuild xref/gnatcoll_xref.gpr \
	  -XLIBRARY_TYPE=static -aPsql -aPsqlite $(gpr_opts)
	gprbuild xref/gnatcoll_xref.gpr \
	  -XLIBRARY_TYPE=relocatable -aPsql -aPsqlite $(gpr_opts)

	gprbuild gnatinspect/gnatinspect.gpr \
	  -XLIBRARY_TYPE=relocatable -aPsql -aPsqlite -aPxref $(gpr_opts)

.PHONY: override_dh_auto_clean
override_dh_auto_clean:
	rm -fr xref/generated \
	  $(addsuffix /lib,sql sqlite xref) \
	  $(addsuffix /obj,sql sqlite xref gnatcoll_db2ada gnatinspect)

# dh_ada_library does not accept -aP arguments.
.PHONY: override_dh_ada_library
override_dh_ada_library:
	ADA_PROJECT_PATH=sql:sqlite:xref \
	dh_ada_library $(foreach l,sql sqlite xref, \
	  LIBRARY_TYPE=relocatable \
	  $(foreach v,$(vars),$(v)="$($(v))") \
	  $(l)/gnatcoll_$(l).gpr)

## libgnatcoll-db 19.2

=== gnatcoll_db2ada/Makefile ===
##############################################################################
##                                                                          ##
##                              GNATCOLL LIBRARY                            ##
##                                                                          ##
##                         Copyright (C) 2017, AdaCore.                     ##
##                                                                          ##
## This library is free software;  you can redistribute it and/or modify it ##
## under terms of the  GNU General Public License  as published by the Free ##
## Software  Foundation;  either version 3,  or (at your  option) any later ##
## version. This library is distributed in the hope that it will be useful, ##
## but WITHOUT ANY WARRANTY;  without even the implied warranty of MERCHAN# ##
## TABILITY or FITNESS FOR A PARTICULAR PURPOSE.                            ##
##                                                                          ##
## As a special exception under Section 7 of GPL version 3, you are granted ##
## additional permissions described in the GCC Runtime Library Exception,   ##
## version 3.1, as published by the Free Software Foundation.               ##
##                                                                          ##
## You should have received a copy of the GNU General Public License and    ##
## a copy of the GCC Runtime Library Exception along with this program;     ##
## see the files COPYING3 and COPYING.RUNTIME respectively.  If not, see    ##
## <http://www.gnu.org/licenses/>.                                          ##
##                                                                          ##
##############################################################################

# Makefile targets
# ----------------
#
# Setup:                   make [VAR=VALUE] setup (see below)
# Build:                   make
# Install:                 make install

# Variables which can be set:
#
# General:
#
#   prefix        : root install directory
#   BUILD         : DEBUG PROD
#   PROCESSORS    : nb parallel compilations (0 to use all cores)
#   TARGET        : target triplet for cross-compilation
#   DB_BACKEND    : either db (no backend), sqlite, postgres or all
#                   (all available backends)

# helper programs
CAT := cat
ECHO  := echo
WHICH := which

DB_BACKEND=db

NAME=gnatcoll_$(DB_BACKEND)2ada

# check for out-of-tree build
SOURCE_DIR := $(dir $(MAKEFILE_LIST))
ifeq ($(SOURCE_DIR),./)
  RBD=
  GNATCOLL_GPR=$(NAME).gpr
  MAKEPREFIX=
else
  RBD=--relocate-build-tree
  GNATCOLL_GPR=$(SOURCE_DIR)/$(NAME).gpr
  MAKEPREFIX=$(SOURCE_DIR)/
endif

TARGET := $(shell gcc -dumpmachine)
NORMALIZED_TARGET := $(subst normalized_target:,,$(wordlist 6,6,$(shell gprconfig  --config=ada --target=$(TARGET) --mi-show-compilers)))
ifeq ($(NORMALIZED_TARGET),)
  $(error No toolchain found for target "$(TARGET)")
endif

prefix := $(dir $(shell $(WHICH) gnatls))..
GNATCOLL_VERSION := $(shell $(CAT) $(SOURCE_DIR)/../version_information)

BUILD         = PROD
PROCESSORS    = 0
BUILD_DIR     =

all: build

# Load current setup if any
-include makefile.setup

GTARGET=--target=$(NORMALIZED_TARGET)

GPR_VARS= \
	 -XLIBRARY_TYPE=static \
	 -XXMLADA_BUILD=static \
	 -XGPR_BUILD=static \
	 -XGNATCOLL_VERSION=$(GNATCOLL_VERSION) \
	 -XBUILD=$(BUILD)

# Used to pass extra options to GPRBUILD, like -d for instance
GPRBUILD_OPTIONS=

BUILDER=gprbuild -p -m $(GTARGET) $(RBD) -j$(PROCESSORS) $(GPR_VARS) \
	$(GPRBUILD_OPTIONS)
INSTALLER=gprinstall -p -f --target=$(TARGET) $(GPR_VARS) \
	$(RBD) --mode=usage --no-project --sources-subdir=include/$(NAME) --prefix=$(prefix)$(integrated_install)
CLEANER=gprclean -q $(GPR_VARS) $(RBD)
UNINSTALLER=$(INSTALLER) -p -f --install-name=$(NAME) --uninstall

#########
# build #
#########

build:
	$(BUILDER) $(GNATCOLL_GPR)

###########
# Install #
###########

uninstall:
ifneq (,$(wildcard $(prefix)/share/gpr/manifests/$(NAME)))
	$(UNINSTALLER) $(GNATCOLL_GPR)
endif

install: uninstall
	$(INSTALLER) $(GNATCOLL_GPR)

###########
# Cleanup #
###########

clean:
	-$(CLEANER) $(GNATCOLL_GPR)

#########
# setup #
#########

.SILENT: setup

setup:
	$(ECHO) "prefix=$(prefix)" > makefile.setup
	$(ECHO) "BUILD=$(BUILD)" >> makefile.setup
	$(ECHO) "PROCESSORS=$(PROCESSORS)" >> makefile.setup
	$(ECHO) "TARGET=$(TARGET)" >> makefile.setup
	$(ECHO) "SOURCE_DIR=$(SOURCE_DIR)" >> makefile.setup
	$(ECHO) "GNATCOLL_VERSION=$(GNATCOLL_VERSION)" >> makefile.setup
	$(ECHO) "DB_BACKEND=$(DB_BACKEND)" >> makefile.setup

# Let gprbuild handle parallelisation. In general, we don't support parallel
# runs in this Makefile, as concurrent gprinstall processes may crash.
.NOTPARALLEL:

=== gnatinspect/Makefile ===
##############################################################################
##                                                                          ##
##                              GNATCOLL LIBRARY                            ##
##                                                                          ##
##                         Copyright (C) 2017, AdaCore.                     ##
##                                                                          ##
## This library is free software;  you can redistribute it and/or modify it ##
## under terms of the  GNU General Public License  as published by the Free ##
## Software  Foundation;  either version 3,  or (at your  option) any later ##
## version. This library is distributed in the hope that it will be useful, ##
## but WITHOUT ANY WARRANTY;  without even the implied warranty of MERCHAN# ##
## TABILITY or FITNESS FOR A PARTICULAR PURPOSE.                            ##
##                                                                          ##
## As a special exception under Section 7 of GPL version 3, you are granted ##
## additional permissions described in the GCC Runtime Library Exception,   ##
## version 3.1, as published by the Free Software Foundation.               ##
##                                                                          ##
## You should have received a copy of the GNU General Public License and    ##
## a copy of the GCC Runtime Library Exception along with this program;     ##
## see the files COPYING3 and COPYING.RUNTIME respectively.  If not, see    ##
## <http://www.gnu.org/licenses/>.                                          ##
##                                                                          ##
##############################################################################

# Makefile targets
# ----------------
#
# Setup:                   make [VAR=VALUE] setup (see below)
# Build:                   make
# Install:                 make install

# Variables which can be set:
#
# General:
#
#   prefix        : root install directory
#   BUILD         : DEBUG PROD
#   PROCESSORS    : nb parallel compilations (0 to use all cores)
#   TARGET        : target triplet for cross-compilation

# helper programs
CAT := cat
ECHO  := echo
WHICH := which

NAME=gnatinspect

# check for out-of-tree build
SOURCE_DIR := $(dir $(MAKEFILE_LIST))
ifeq ($(SOURCE_DIR),./)
  RBD=
  GNATCOLL_GPR=$(NAME).gpr
  MAKEPREFIX=
else
  RBD=--relocate-build-tree
  GNATCOLL_GPR=$(SOURCE_DIR)/$(NAME).gpr
  MAKEPREFIX=$(SOURCE_DIR)/
endif

TARGET := $(shell gcc -dumpmachine)
NORMALIZED_TARGET := $(subst normalized_target:,,$(wordlist 6,6,$(shell gprconfig  --config=ada --target=$(TARGET) --mi-show-compilers)))
ifeq ($(NORMALIZED_TARGET),)
  $(error No toolchain found for target "$(TARGET)")
endif

prefix := $(dir $(shell $(WHICH) gnatls))..
GNATCOLL_VERSION := $(shell $(CAT) $(SOURCE_DIR)/../version_information)

BUILD         = PROD
PROCESSORS    = 0
BUILD_DIR     =

all: build

# Load current setup if any
-include makefile.setup

GTARGET=--target=$(NORMALIZED_TARGET)

LIBRARY_TYPE=static

GPR_VARS= \
	 -XLIBRARY_TYPE=$(LIBRARY_TYPE) \
	 -XXMLADA_BUILD=$(LIBRARY_TYPE) \
	 -XGPR_BUILD=$(LIBRARY_TYPE) \
	 -XGNATCOLL_VERSION=$(GNATCOLL_VERSION) \
	 -XBUILD=$(BUILD)

# Used to pass extra options to GPRBUILD, like -d for instance
GPRBUILD_OPTIONS=

BUILDER=gprbuild -p -m $(GTARGET) $(RBD) -j$(PROCESSORS) $(GPR_VARS) \
	$(GPRBUILD_OPTIONS)
INSTALLER=gprinstall -p -f --target=$(TARGET) $(GPR_VARS) \
	$(RBD) --no-project --mode=usage --sources-subdir=include/$(NAME) --prefix=$(prefix)$(integrated_install)
CLEANER=gprclean -q $(GPR_VARS) $(RBD)
UNINSTALLER=$(INSTALLER) -p -f --install-name=$(NAME) --uninstall

#########
# build #
#########

build:
	$(BUILDER) $(GNATCOLL_GPR)

###########
# Install #
###########

uninstall:
ifneq (,$(wildcard $(prefix)/share/gpr/manifests/$(NAME)))
	$(UNINSTALLER) $(GNATCOLL_GPR)
endif

install: uninstall
	$(INSTALLER) $(GNATCOLL_GPR)

###########
# Cleanup #
###########

clean:
	-$(CLEANER) $(GNATCOLL_GPR)

#########
# setup #
#########

.SILENT: setup

setup:
	$(ECHO) "prefix=$(prefix)" > makefile.setup
	$(ECHO) "BUILD=$(BUILD)" >> makefile.setup
	$(ECHO) "PROCESSORS=$(PROCESSORS)" >> makefile.setup
	$(ECHO) "TARGET=$(TARGET)" >> makefile.setup
	$(ECHO) "SOURCE_DIR=$(SOURCE_DIR)" >> makefile.setup
	$(ECHO) "GNATCOLL_VERSION=$(GNATCOLL_VERSION)" >> makefile.setup

# Let gprbuild handle parallelisation. In general, we don't support parallel
# runs in this Makefile, as concurrent gprinstall processes may crash.
.NOTPARALLEL:

=== postgres/Makefile ===
##############################################################################
##                                                                          ##
##                              GNATCOLL LIBRARY                            ##
##                                                                          ##
##                         Copyright (C) 2017, AdaCore.                     ##
##                                                                          ##
## This library is free software;  you can redistribute it and/or modify it ##
## under terms of the  GNU General Public License  as published by the Free ##
## Software  Foundation;  either version 3,  or (at your  option) any later ##
## version. This library is distributed in the hope that it will be useful, ##
## but WITHOUT ANY WARRANTY;  without even the implied warranty of MERCHAN# ##
## TABILITY or FITNESS FOR A PARTICULAR PURPOSE.                            ##
##                                                                          ##
## As a special exception under Section 7 of GPL version 3, you are granted ##
## additional permissions described in the GCC Runtime Library Exception,   ##
## version 3.1, as published by the Free Software Foundation.               ##
##                                                                          ##
## You should have received a copy of the GNU General Public License and    ##
## a copy of the GCC Runtime Library Exception along with this program;     ##
## see the files COPYING3 and COPYING.RUNTIME respectively.  If not, see    ##
## <http://www.gnu.org/licenses/>.                                          ##
##                                                                          ##
##############################################################################

# Makefile targets
# ----------------
#
# Setup:                   make [VAR=VALUE] setup (see below)
# Build:                   make
# Install:                 make install

# Variables which can be set:
#
# General:
#
#   prefix        : root install directory
#   ENABLE_SHARED : yes / no (or empty)
#   BUILD         : DEBUG PROD
#   PROCESSORS    : nb parallel compilations (0 to use all cores)
#   TARGET        : target triplet for cross-compilation
#   INTEGRATED    : installs the project as part of the compiler installation;
#                   this adds NORMALIZED_TARGET subdir to prefix
#
# Project specific:
#
#   GNATCOLL_HASPQPREPARE : whether PQPREPARE is available (yes/no)
#                     default is "yes"

# helper programs
CAT := cat
ECHO  := echo
WHICH := which

NAME=gnatcoll_postgres

# check for out-of-tree build
SOURCE_DIR := $(dir $(MAKEFILE_LIST))
ifeq ($(SOURCE_DIR),./)
  RBD=
  GNATCOLL_GPR=$(NAME).gpr
  MAKEPREFIX=
else
  RBD=--relocate-build-tree
  GNATCOLL_GPR=$(SOURCE_DIR)/$(NAME).gpr
  MAKEPREFIX=$(SOURCE_DIR)/
endif

TARGET := $(shell gcc -dumpmachine)
NORMALIZED_TARGET := $(subst normalized_target:,,$(wordlist 6,6,$(shell gprconfig  --config=ada --target=$(TARGET) --mi-show-compilers)))
ifeq ($(NORMALIZED_TARGET),)
  $(error No toolchain found for target "$(TARGET)")
endif

prefix := $(dir $(shell $(WHICH) gnatls))..
GNATCOLL_VERSION := $(shell $(CAT) $(SOURCE_DIR)/../version_information)
GNATCOLL_HASPQPREPARE := yes

BUILD         = PROD
PROCESSORS    = 0
BUILD_DIR     =
ENABLE_SHARED := yes
INTEGRATED    = no

all: build

# Load current setup if any
-include makefile.setup

GTARGET=--target=$(NORMALIZED_TARGET)

ifeq ($(ENABLE_SHARED), yes)
   LIBRARY_TYPES=static relocatable static-pic
else
   LIBRARY_TYPES=static
endif

ifeq ($(INTEGRATED), yes)
   integrated_install=/$(NORMALIZED_TARGET)
endif

GPR_VARS= \
	 -XGNATCOLL_HASPQPREPARE=$(GNATCOLL_HASPQPREPARE) \
	 -XGNATCOLL_VERSION=$(GNATCOLL_VERSION) \
	 -XBUILD=$(BUILD)

# Used to pass extra options to GPRBUILD, like -d for instance
GPRBUILD_OPTIONS=

BUILDER=gprbuild -p -m $(GTARGET) $(RBD) -j$(PROCESSORS) $(GPR_VARS) \
	$(GPRBUILD_OPTIONS)
INSTALLER=gprinstall -p -f --target=$(TARGET) $(GPR_VARS) \
	$(RBD) --sources-subdir=include/$(NAME) --prefix=$(prefix)$(integrated_install)
CLEANER=gprclean -q $(RBD) $(GPR_VARS)
UNINSTALLER=$(INSTALLER) -p -f --install-name=$(NAME) --uninstall

#########
# build #
#########

build: $(LIBRARY_TYPES:%=build-%)

build-%:
	$(BUILDER) -XLIBRARY_TYPE=$* -XXMLADA_BUILD=$* -XGPR_BUILD=$* \
		$(GNATCOLL_GPR)

###########
# Install #
###########

uninstall:
ifneq (,$(wildcard $(prefix)/share/gpr/manifests/$(NAME)))
	$(UNINSTALLER) $(GNATCOLL_GPR)
endif

install: uninstall $(LIBRARY_TYPES:%=install-%)

install-%:
	$(INSTALLER) -XLIBRARY_TYPE=$* -XXMLADA_BUILD=$* -XGPR_BUILD=$* \
		--build-name=$* --build-var=LIBRARY_TYPE $(GNATCOLL_GPR)

###########
# Cleanup #
###########

clean: $(LIBRARY_TYPES:%=clean-%)

clean-%:
	-$(CLEANER) -XLIBRARY_TYPE=$* -XXMLADA_BUILD=$* -XGPR_BUILD=$* \
		$(GNATCOLL_GPR)

#########
# setup #
#########

.SILENT: setup

setup:
	$(ECHO) "prefix=$(prefix)" > makefile.setup
	$(ECHO) "ENABLE_SHARED=$(ENABLE_SHARED)" >> makefile.setup
	$(ECHO) "INTEGRATED=$(INTEGRATED)" >> makefile.setup
	$(ECHO) "BUILD=$(BUILD)" >> makefile.setup
	$(ECHO) "PROCESSORS=$(PROCESSORS)" >> makefile.setup
	$(ECHO) "TARGET=$(TARGET)" >> makefile.setup
	$(ECHO) "SOURCE_DIR=$(SOURCE_DIR)" >> makefile.setup
	$(ECHO) "GNATCOLL_VERSION=$(GNATCOLL_VERSION)" >> makefile.setup
	$(ECHO) "GNATCOLL_HASPQPREPARE=$(GNATCOLL_HASPQPREPARE)" >> makefile.setup

# Let gprbuild handle parallelisation. In general, we don't support parallel
# runs in this Makefile, as concurrent gprinstall processes may crash.
.NOTPARALLEL:

=== debian/changelog ===
libgnatcoll-db (19.2-3) unstable; urgency=medium

  [ Aurelien Jarno <aurelien@aurel32.net> ]
  * Compile with mixgot option on mipsel. Closes: #953069.

 -- Nicolas Boulenguez <nicolas@debian.org>  Wed, 25 Mar 2020 15:40:52 +0100

libgnatcoll-db (19.2-2) unstable; urgency=medium

  * Reupload to unstable for gnat-9 transition.
  * Use debhelper 12 dh-sequence- syntax.
  * Standards-Version: 4.5.0.

 -- Nicolas Boulenguez <nicolas@debian.org>  Tue, 25 Feb 2020 17:48:18 +0100

libgnatcoll-db (19.2-1) experimental; urgency=medium

  * New upstream release, rebuilt with gcc-9 and updated dependencies.
    Rename lib and -dev packages accordingly.
  * Source is now only available as github commits instead of tarballs.
    Update Homepage, Source. Provide a script recreating the .orig.
  * Though distributed differently, the GPL versions do *not* provide
    the GCC Runtime exception to non-paying customers.
  * Track packaging history at salsa.debian.org.
  * Debhelper 12. Standards-Version 4.4.1, sort dependencies.
  * Fix a gpr project attribute name in link-pthread.diff.
  * Enable all linker warnings.
  * Only include specific dpkg-dev snippet.
  * Update autopkgtest variable name for temporary directory.

 -- Nicolas Boulenguez <nicolas@debian.org>  Sun, 15 Dec 2019 17:47:27 +0100

=== debian/control ===
--- 
+++ 
@@ -2,23 +2,24 @@
 Priority: optional
 Section: misc
 Maintainer: Nicolas Boulenguez <nicolas@debian.org>
-Build-Depends: debhelper (>= 11),
- gnat, gnat-8,
+Build-Depends:
+ debhelper-compat (= 12),
+ dh-sequence-ada-library,
+ gnat, gnat-9,
 # This line is parsed to set gnat version.
-# dh-ada-library allowing .ada extension.
- dh-ada-library (>= 6.10),
-# gprbuild cleaning auto.cgpr.
  gprbuild (>= 2017),
- libgnatcoll17-dev,
- libgnatcoll-iconv17-dev,
- libsqlite3-dev
-Homepage: https://www.adacore.com/community
-Standards-Version: 4.2.0
+ libgnatcoll18-dev,
+ libgnatcoll-iconv18-dev,
+ libsqlite3-dev,
+Homepage: https://github.com/AdaCore/gnatcoll-db
+Standards-Version: 4.5.0
 Rules-Requires-Root: no
+Vcs-Browser: https://salsa.debian.org/debian/libgnatcoll-db
+Vcs-Git: https://salsa.debian.org/debian/libgnatcoll-db.git
 
 ######################################################################
 
-Package: libgnatcoll-sqlite17-dev
+Package: libgnatcoll-sqlite18-dev
 Section: libdevel
 Architecture: any
 Depends: libsqlite3-dev, ${misc:Depends}, ${ada:Depends}
@@ -33,7 +34,7 @@
  This package contains the static library and Ada specifications
  dedicated to SQLite databases manipulation.
 
-Package: libgnatcoll-sqlite18
+Package: libgnatcoll-sqlite19
 Section: libs
 Architecture: any
 Pre-Depends: ${misc:Pre-Depends}
@@ -53,9 +54,6 @@
 Section: devel
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
-# gnat-gps used to provide gnatinspect.
-Breaks: gnat-gps (<< 5.3-4)
-Replaces: gnat-gps (<< 5.3-4)
 Suggests: libgnatcoll-doc
 Description: GNATColl, general purpose Ada library (SQLite tools)
  The GNAT Component Collection deals with: module tracing, efficient
@@ -72,7 +70,7 @@
 
 ######################################################################
 
-Package: libgnatcoll-sql1-dev
+Package: libgnatcoll-sql2-dev
 Section: libdevel
 Architecture: any
 Depends: ${misc:Depends}, ${ada:Depends}
@@ -90,7 +88,7 @@
  It connects to actual databases via a sqlite or a postgres backend,
  but only the former exists in Debian due to license reasons.
 
-Package: libgnatcoll-sql1
+Package: libgnatcoll-sql2
 Section: libs
 Architecture: any
 Pre-Depends: ${misc:Pre-Depends}
@@ -108,7 +106,7 @@
 
 ######################################################################
 
-Package: libgnatcoll-xref18-dev
+Package: libgnatcoll-xref19-dev
 Section: libdevel
 Architecture: any
 Depends: ${misc:Depends}, ${ada:Depends}
@@ -123,7 +121,7 @@
  This package contains the static library and Ada specifications
  for the XRef extension.
 
-Package: libgnatcoll-xref18
+Package: libgnatcoll-xref19
 Section: libs
 Architecture: any
 Pre-Depends: ${misc:Pre-Depends}

=== debian/rules ===
--- 
+++ 
@@ -1,6 +1,6 @@
 #!/usr/bin/make -f
-# Build script for GNATColl in Debian.
-# Copyright (c) 2014-2018 Nicolas Boulenguez <nicolas@debian.org>
+# Build script for GNATColl database components in Debian.
+# Copyright (c) 2014-2019 Nicolas Boulenguez <nicolas@debian.org>
 
 # This build script is free software; you can redistribute it and/or
 # modify it under the terms of the GNU General Public License as
@@ -21,7 +21,16 @@
   ' debian/control),$(eval $(line)))
 
 DEB_BUILD_MAINT_OPTIONS := hardening=+all
-include /usr/share/dpkg/default.mk
+DEB_LDFLAGS_MAINT_APPEND := -Wl,--no-undefined \
+  -Wl,--no-copy-dt-needed-entries -Wl,--no-allow-shlib-undefined
+
+# On mipsel gnatcoll-xref.adb generates long jump that do not fit in
+# standard branch instructions. Use the mxgot option to workaround that.
+ifeq ($(DEB_HOST_ARCH),mipsel)
+  DEB_CFLAGS_MAINT_APPEND := -mxgot
+endif
+
+include /usr/share/dpkg/buildflags.mk
 include /usr/share/ada/debian_packaging-$(GNAT_VERSION).mk
 
 # The scenario variables passed to gprbuild and dh_ada_library.
@@ -38,7 +47,7 @@
 gpr_opts := -p $(BUILDER_OPTIONS) $(foreach v,$(vars),-X$(v)="$($(v))")
 
 %:
-	dh $@ --with ada-library
+	dh $@
 
 # Dependencies and parallelism are handled by gprbuild,
 # avoid using Make for this (risky, without much gain).
